import javax.persistence.*;

public class Main {

    /* This program works both in Java SE as well as Java EE environment */
    @PersistenceUnit private static EntityManagerFactory emf;

    public static void main(String... args) throws Exception {
        if(emf == null) { // no injection => Java SE
            System.out.println("Defaulting to Java SE enviroment");
            emf = Persistence.createEntityManagerFactory("pu1", null);
        }
        EntityManager em = emf.createEntityManager();
        if(args.length != 2) {
            System.out.println("Usage: java "+ Main.class.getName() + " eventId alarmId");
            System.exit(1);
        }
        {
            EntityTransaction et = em.getTransaction();
            et.begin();
            EventPK eventPK = new EventPK(args[0], EventInformationT.class.getSimpleName());
            System.out.println("*******Finding event " + eventPK);
	    EventInformationT event = em.find(EventInformationT.class, eventPK);
            if(event == null) {
                System.out.println("Creating event " + eventPK);
                event = new EventInformationT();
                event.setNotificationId(eventPK.getNotificationId());
                em.persist(event);
            } else {
                System.out.println("Found " + event);
            }
            EventPK alarmPK = new EventPK(args[1], AlarmT.class.getSimpleName());
            System.out.println("*******Finding alarm " + alarmPK);
	    AlarmT alarm = em.find(AlarmT.class, alarmPK);
            if(alarm == null) {
                System.out.println("Creating alarm " + alarmPK);
                alarm = new AlarmT();
                alarm.setNotificationId(alarmPK.getNotificationId());
                em.persist(alarm);
            } else {
                System.out.println("Found " + alarm);
            }
            et.commit();
        }
        em.close();
    }
}
